/// <reference types="node" />
import type { AsyncExecutionResult, ExecutionArgs, ExecutionResult } from "graphql";
import type { Readable } from "node:stream";
import type { GrafservBase } from "./index.js";
import type { GrafservBody, NormalizedRequestDigest, RequestDigest } from "./interfaces.js";
export declare function handleErrors(payload: ExecutionResult | AsyncExecutionResult): void;
type IncomingHttpHeaders = Record<string, string | string[] | undefined>;
export declare function processHeaders(headers: IncomingHttpHeaders): Record<string, string>;
export declare function getBodyFromRequest(req: Readable, maxLength: number): Promise<GrafservBody>;
export declare function getBodyFromFrameworkBody(body: unknown): GrafservBody;
export declare function memo<T>(fn: () => T): () => T;
export declare function normalizeRequest(request: RequestDigest | NormalizedRequestDigest): NormalizedRequestDigest;
export declare function httpError(statusCode: number, message: string): Error & {
    statusCode: number;
};
export declare function makeGraphQLWSConfig(instance: GrafservBase): {
    schema: () => Promise<import("graphql").GraphQLSchema>;
    execute: (args: ExecutionArgs) => Promise<ExecutionResult<import("graphql/jsutils/ObjMap.js").ObjMap<unknown>, import("graphql/jsutils/ObjMap.js").ObjMap<unknown>> | AsyncGenerator<AsyncExecutionResult, void, undefined>>;
    subscribe: (args: ExecutionArgs) => Promise<ExecutionResult<import("graphql/jsutils/ObjMap.js").ObjMap<unknown>, import("graphql/jsutils/ObjMap.js").ObjMap<unknown>> | AsyncGenerator<ExecutionResult<import("graphql/jsutils/ObjMap.js").ObjMap<unknown>, import("graphql/jsutils/ObjMap.js").ObjMap<unknown>> | AsyncExecutionResult, void, void>>;
};
export {};
//# sourceMappingURL=utils.d.ts.map